#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
ll ma[2][1000000+1];
int main(){
	ll n,k;
	cin >> n >> k;
	ll a,nule=0,br=0;
	for(ll i=0;i<n;i++){
		cin >> a;
		if(a<0){
			if(ma[0][abs(a)]==k-1){
				br++;
				ma[0][abs(a)]++;
			}
			else ma[0][abs(a)]++;
		}else if(a>0){
			if(ma[1][a]==k-1){
				br++;
				ma[1][a]++;
			}
			else ma[1][a]++;
		}else{
			if(nule==k-1){
				br++;
				nule++;
			}
			else nule++;
		}
	}
	cout<<br<<endl;
	for(ll i=0;i<n;i++){
		if(ma[0][i]>=k)cout<<i*(-1)<<" ";
		if(ma[1][i]>=k)cout<<i<<" ";
	}
	if(nule>=k)cout<<0;
	return 0;
}